import React from 'react';
import { Box, Segment, Text } from '../elements';
import { Loader } from '../modules';
import { Menu, MenuItem } from '../collections';
import { useConfig } from './context';
import { useWidget } from './widgets';
import styled from 'styled-components';
var WidgetContent = function (_a) {
    var config = _a.config;
    var Component = useWidget(config.as);
    return React.createElement(Component, { config: config }, config.content);
};
export var WidgetMenu = function (_a) {
    var config = _a.config, color = _a.color;
    if (!config.title) {
        return null;
    }
    return (React.createElement(Menu, null,
        React.createElement(MenuItem, null,
            React.createElement(Text, { as: "span", color: color }, config.title))));
};
var WidgetSegment = styled(Segment)({
    overflowY: 'auto',
    margin: 0,
    '& h1, h2, h3': {
        color: 'inherit',
    },
});
export var Widget = function (_a) {
    var config = _a.config;
    var _b = useConfig(), color = _b.color, _c = _b.gridSize, gridSize = _c === void 0 ? 4 : _c;
    var size = 100 / gridSize;
    var width = ((config.size || 1) * size).toString() + 'vw';
    var height = size + 'vw';
    return (React.createElement(Box, { width: width, height: height, padded: true, stretched: true },
        React.createElement(WidgetSegment, { raised: !config.basic, color: config.backgroundColor },
            React.createElement(WidgetMenu, { config: config, color: color }),
            React.createElement(React.Suspense, { fallback: React.createElement(Loader, { active: true }) },
                React.createElement(WidgetContent, { config: config })))));
};
